﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.IO;
using System.Threading;
using System.Net;
using System.Management;

namespace NagiosVMToolCheck
{
  class Program
  {
    public static string path = Environment.GetEnvironmentVariable("ProgramW6432") + "\\VMware\\VMware Tools\\VMwareToolboxCmd.exe";
    public static string pathWin2003 = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + "\\VMware\\VMware Tools\\VMwareToolboxCmd.exe";
    public static long MemSize = 0;
    public static uint cpuSpeed;

    private static long Memlimit = 0;
    private static long Memres = 0;
    private static long CPUlimit = 0;
    private static long CPUres = 0;
    private static int coreCount = 0;

    private static string execUnixEpochTime = string.Empty;
    static void Main(string[] args)
    {
      bool info = false;
      string bbb = Environment.GetEnvironmentVariable("ProgramW6432");
      if (args.Length > 0)
      {
        for (int i = 0; i < args.Length; i++)
        {
          switch (args[i])
          {
            case "-info":
              info = true;
              break;
            case "-Path":
              if (args.Length > i + 1)
              {
                //save disk unit
                path = args[++i];
              }
              else
              {
                Console.WriteLine("ERROR in parsing argument -path: missing value");
                Environment.Exit(3);
              }
              break;
            default:
              info = true;
              break;
          }
        }
      }
      if (!info)
      {
      
          AutoResetEvent signal2 = new AutoResetEvent(false);
          Thread workerThread2 = null;


          ThreadPool.QueueUserWorkItem((o) =>
          {
            workerThread2 = Thread.CurrentThread;

            Worker();
            signal2.Set();
          });
          new Timer((o) => { signal2.Set(); }, null, 5000, Timeout.Infinite);

          signal2.WaitOne();

          if (workerThread2 != null && workerThread2.IsAlive)
            workerThread2.Abort();
       
      }
      else
      {
        #region Help
        StringBuilder help = new StringBuilder();

        help.AppendLine("Author: Matthias Göpel");
        help.AppendLine();
        help.AppendLine("Dieses Programm ruft die VMwareToolboxCmd.exe mit Parametern stat balloon,stat swap, stat memlimit, stat memres,");
        help.AppendLine("stat cpures, stat cpulimit, timesync status und upgrade status auf und gibt das Ergebnis aus.");
        help.AppendLine();
        help.AppendLine("Übergabeparamerter:");
        help.AppendLine();
        help.AppendLine("    -info <Ruft diese Info ab>");
        help.AppendLine("    -path <Alternativer Pfad falls die VMwareToolboxCmd.exe nicht unter");
        help.AppendLine("          C:\\Program Files\\VMware\\VMware Tools\\VMwareToolboxCmd.exe liegt>");
        help.AppendLine();
        help.AppendLine("Beispiel für Ausgabe:");
        help.AppendLine();
        help.AppendLine("ballon	<TABULATOR>	wert");
        help.AppendLine("swap	<TABULATOR>	wert");
        Console.WriteLine(help);
        #endregion
      }
    }
    private static void getCPUCore()
    {
      try
      {

        foreach (var item in new System.Management.ManagementObjectSearcher("Select * from Win32_Processor").Get())
        {
          coreCount += int.Parse(item["NumberOfCores"].ToString());
        }

      }
      catch (Exception)
      {
        coreCount = Environment.ProcessorCount;
      }

    }
  
    private static void Worker()
    {
      bool fileExist = true;
      cpuSpeed = CPUSpeed();
      Console.WriteLine("<<<vm_check>>>");
      
      if (!File.Exists(path))
      {
        if (File.Exists(pathWin2003))
        {
          path = pathWin2003;
        }
        else
        {
          fileExist = false;
        }
      }
      if (fileExist)
      {
        Console.WriteLine(Dns.GetHostName() + "|Version|;|||||1.4.4");
        #region Variablen füllen
        GetMemSize();
        TimeSpan t = (DateTime.UtcNow - new DateTime(1970, 1, 1));

        int timestamp = (int)t.TotalSeconds;

        execUnixEpochTime = timestamp.ToString();
        #endregion
       
        #region Checks
        Check("stat balloon");
        Check("stat swap");
        Check("stat memlimit");
        Check("stat memres");
        Check("stat cpures");
        Check("stat cpulimit");
        Check("timesync status");
        Check("upgrade status");
        #endregion

        
        #region CPU /MEM


        Console.WriteLine(Dns.GetHostName() + "|Memlimit-Memres|" + Memlimit + ";" + Memres + "|MB|" + execUnixEpochTime + "|" + MemSize + "|ok|");
        
        Console.WriteLine(Dns.GetHostName() + "|CPUlimit-CPUres|" + CPUlimit + ";" + CPUres + "|MHz|" + execUnixEpochTime + "|" + cpuSpeed + "|ok|");
        #endregion

        #region CPU  Cores
        //int coreCount = 0;
        //try
        //{

        //  foreach (var item in new System.Management.ManagementObjectSearcher("Select * from Win32_Processor").Get())
        //  {
        //    coreCount += int.Parse(item["NumberOfCores"].ToString());
        //  }
        //  Console.WriteLine("NumberOfCores: " + coreCount);
        //  Console.WriteLine();
        //}
        //catch (Exception ex)
        //{
        //  Console.WriteLine("Error: NumberOFCores: " + ex.ToString());
        //  Console.WriteLine();
        //}
        //try
        //{
        //  coreCount = Environment.ProcessorCount;
        //  Console.WriteLine("ProcessorCount: " + coreCount);
        //  Console.WriteLine();
        //}
        //catch (Exception ex)
        //{
        //  Console.WriteLine("Error: ProcessorCount: " + ex.ToString());
        //  Console.WriteLine();
        //}
        //try
        //{
        //  foreach (var item in new System.Management.ManagementObjectSearcher("Select * from Win32_ComputerSystem").Get())
        //  {
        //    Console.WriteLine("Number Of Physical Processors: {0} ", item["NumberOfProcessors"]);
        //    Console.WriteLine();
        //  }

        //}
        //catch (Exception ex)
        //{

        //  Console.WriteLine("Error: Number of Pysical " + ex.ToString());
        //  Console.WriteLine();
        //}
        //try
        //{
        //  foreach (var item in new System.Management.ManagementObjectSearcher("Select * from Win32_ComputerSystem").Get())
        //  {
        //    Console.WriteLine("Number Of Logical Processors: {0}", item["NumberOfLogicalProcessors"]);
        //    Console.WriteLine();
        //  }

        //}
        //catch (Exception ex)
        //{

        //  Console.WriteLine("Error: Logical Procces" + ex.ToString());
        //  Console.WriteLine();
        //}


        //Console.WriteLine(Dns.GetHostName() + "|Memlimit-Memres|" + Memlimit + ";" + Memres + "|MB|" + execUnixEpochTime + "|" + MemSize + "|ok|");
        //Console.WriteLine(Dns.GetHostName() + "|CPUlimit-CPUres|" + CPUlimit + ";" + CPUres + "|MHz|" + execUnixEpochTime + "|" + cpuSpeed + ";" + (coreCount == 0 ? "" : coreCount.ToString()) + "|ok|");
        #endregion
      }
      else
      {
        Console.WriteLine(Dns.GetHostName() + "||;||" + execUnixEpochTime + "||no_binary|");
      }
    }
    private static void Check(string arguments)
    {
      try
      {
        Process compiler = new Process();
        compiler.StartInfo.FileName = path;
        compiler.StartInfo.Arguments = arguments;
        compiler.StartInfo.UseShellExecute = false;
        compiler.StartInfo.RedirectStandardOutput = true;

        compiler.StartInfo.CreateNoWindow = true;
        

        compiler.Start();
        using (StreamReader sr = compiler.StandardOutput)
        {
          string[] returnVal = arguments.Split(' ');

          while (!sr.EndOfStream)
          {

            if (returnVal[0] == "stat")
            {
              string[] readline = sr.ReadLine().Split(' ');

              switch (returnVal[1])
              {
                case "balloon":
                  Console.WriteLine(Dns.GetHostName() + "|Balloon|" + readline[0] + ";|" + readline[1] + "|" + execUnixEpochTime + "|" + MemSize + "|ok|");
                  break;
                case "swap":
                  Console.WriteLine(Dns.GetHostName() + "|Swap|" + readline[0] + ";|" + readline[1] + "|" + execUnixEpochTime + "|" + MemSize + "|ok|");
                  break;
                case "memlimit":
                  //Console.WriteLine(Dns.GetHostName() + "|Memlimit|" + readline[0] + ";|" + readline[1] + "|" + execUnixEpochTime + "|"+MemSize+"|ok|");
                  long.TryParse(readline[0], out Memlimit);
                  break;
                case "memres":
                  // Console.WriteLine(Dns.GetHostName() + "|Memres|" + readline[0] + ";|" + readline[1] + "|" + execUnixEpochTime + "|"+MemSize+"|ok|");
                  long.TryParse(readline[0], out Memres);
                  break;
                case "cpures":
                  // Console.WriteLine(Dns.GetHostName() + "|CPUres|" + readline[0] + ";|" + readline[1] + "|" + execUnixEpochTime + "||ok|");
                  long.TryParse(readline[0], out CPUres);
                  break;
                case "cpulimit":
                  // Console.WriteLine(Dns.GetHostName() + "|CPUlimit|" + readline[0] + ";|" + readline[1] + "|" + execUnixEpochTime + "||ok|");
                  long.TryParse(readline[0], out CPUlimit);
                  break;
              }
            }
            else
            {
              if (returnVal[0] == "timesync")
              {
                Console.WriteLine(Dns.GetHostName() + "|timesync status|" + sr.ReadLine() + ";||" + execUnixEpochTime + "||ok|");
              }
              else
              {
                //upgrade
                Console.WriteLine(Dns.GetHostName() + "|upgrade status|" + sr.ReadLine() + ";||" + execUnixEpochTime + "||ok|");
              }
            }


            //.Replace(" ",  "\t"));
          }
          int exitCode = compiler.ExitCode;
          if (exitCode != 0 && exitCode != 69)
          {
            if (returnVal[0] == "stat")
            {
              Console.WriteLine(Dns.GetHostName() + "|" + returnVal[1] + "|;||" + execUnixEpochTime + "||na|");
            }
            else
            {
              Console.WriteLine(Dns.GetHostName() + "|" + arguments + "|;||" + execUnixEpochTime + "||na|");
            }
          }
          compiler.WaitForExit();
        }

      }
      catch (Exception ex)
      {
        Console.WriteLine("Error " + ex.Message);
      }
    }
    private static void GetMemSize()
    {
      ManagementScope oMs = new ManagementScope();
      ObjectQuery oQuery = new ObjectQuery("SELECT Capacity FROM Win32_PhysicalMemory");
      ManagementObjectSearcher oSearcher = new ManagementObjectSearcher(oMs, oQuery);
      ManagementObjectCollection oCollection = oSearcher.Get();

      long mCap = 0;

      // In case more than one Memory sticks are installed
      foreach (ManagementObject obj in oCollection)
      {
        mCap = Convert.ToInt64(obj["Capacity"]);
        MemSize += mCap;
      }
      MemSize = (MemSize / 1024) / 1024;

    }
    public static uint CPUSpeed()
    {
      uint sp = 0;
      try
      {
        ManagementObject Mo = new ManagementObject("Win32_Processor.DeviceID='CPU0'");
        sp = (uint)(Mo["CurrentClockSpeed"]);
        Mo.Dispose();
      }
      catch (Exception ex)
      {
        Console.WriteLine("Error CPUSPEED" + ex.ToString());
      }
      return sp;
    }

  }
}
